org.eclipse.viatra.query.runtime.matchers.util

## Class EclipseCollectionsBagMemory<T>

- java.lang.Object
- - org.eclipse.collections.impl.map.mutable.primitive.ObjectIntHashMap<T>
  - - org.eclipse.viatra.query.runtime.matchers.util.EclipseCollectionsBagMemory<T>

- All Implemented Interfaces:
    java.io.Externalizable, java.io.Serializable, java.lang.Iterable<T>, org.eclipse.collections.api.IntIterable, org.eclipse.collections.api.map.primitive.MutableObjectIntMap<T>, org.eclipse.collections.api.map.primitive.ObjectIntMap<T>, org.eclipse.collections.api.PrimitiveIterable, Clearable, IMemory<T>, IMemoryView<T>
  Direct Known Subclasses:
    EclipseCollectionsDeltaBag, EclipseCollectionsMultiset

      public abstract class EclipseCollectionsBagMemory<T>
      extends org.eclipse.collections.impl.map.mutable.primitive.ObjectIntHashMap<T>
      implements IMemory<T>

  Eclipse Collections-based multiset for tuples. Can contain duplicate occurrences of the same matching.

  Inherits Eclipse Collections' Object-to-Int primitive hashmap and counts the number of occurrences of each value. Element is deleted if # of occurences drops to 0.

  Since:
    1.7
  See Also:
    Serialized Form
  No Reference:

- - ### Field Summary

    - ### Fields inherited from class org.eclipse.collections.impl.map.mutable.primitive.ObjectIntHashMap

      `EMPTY_VALUE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EclipseCollectionsBagMemory()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clearAllOf(T value)` Removes all occurrences of the given value from the memory.
    `boolean` | `containsNonZero(T value)`
    `boolean` | `containsNonZeroUnsafe(java.lang.Object value)`
    `java.util.Set<T>` | `distinctValues()` The set of distinct values
    `boolean` | `equals(java.lang.Object obj)`
    `void` | `forEachEntryWithMultiplicities(java.util.function.BiConsumer<T,java.lang.Integer> entryConsumer)` Process contained values with their multiplicities
    `int` | `getCount(T value)` Returns the number of occurrences of the given value.
    `int` | `getCountUnsafe(java.lang.Object value)` Returns the number of occurrences of the given value (which may be of any type).
    `int` | `hashCode()`
    `java.util.Iterator<T>` | `iterator()`
    `java.lang.String` | `toString()`

    - ### Methods inherited from class org.eclipse.collections.impl.map.mutable.primitive.ObjectIntHashMap

      `addToValue, allocateTable, allSatisfy, anySatisfy, appendString, appendString, appendString, asLazy, asSynchronized, asUnmodifiable, average, chunk, clear, collect, compact, contains, containsAll, containsAll, containsKey, containsValue, count, detectIfNone, each, flipUniqueValues, forEach, forEachKey, forEachKeyValue, forEachValue, get, getIfAbsent, getIfAbsentPut, getIfAbsentPut, getIfAbsentPutWith, getIfAbsentPutWithKey, getOrThrow, injectInto, intIterator, isEmpty, keySet, keysView, keyValuesView, makeString, makeString, makeString, max, maxIfEmpty, median, min, minIfEmpty, newMap, newWithKeysValues, newWithKeysValues, newWithKeysValues, newWithKeysValues, noneSatisfy, notEmpty, put, putAll, readExternal, reject, reject, remove, removeKey, removeKeyIfAbsent, select, select, size, sum, toArray, toBag, toImmutable, toList, toSet, toSortedArray, toSortedList, updateValue, updateValues, values, withKeysValues, withKeysValues, withKeysValues, withKeyValue, withoutAllKeys, withoutKey, writeExternal`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.eclipse.viatra.query.runtime.matchers.util.IMemory

      `addOne, addSigned, clear, removeOne, removeOneOrNop`

    - ### Methods inherited from interface org.eclipse.viatra.query.runtime.matchers.util.IMemoryView

      `asMap, asStream, entriesWithMultiplicities, equals, fromMap, hashCode, isEmpty, size, theContainedVersionOf, theContainedVersionOfUnsafe`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

    - ### Methods inherited from interface org.eclipse.collections.api.map.primitive.MutableObjectIntMap

      `putPair, tap, withAllKeyValues`

    - ### Methods inherited from interface org.eclipse.collections.api.IntIterable

      `averageIfEmpty, collect, collectBoolean, collectByte, collectChar, collectDouble, collectFloat, collectInt, collectLong, collectShort, flatCollect, medianIfEmpty, reduce, reduceIfEmpty, reject, select, summaryStatistics`

- - ### Constructor Detail

    - #### EclipseCollectionsBagMemory

          public EclipseCollectionsBagMemory()

  - ### Method Detail

    - #### getCount

          public int getCount(T value)

      Description copied from interface: `IMemoryView`
      Returns the number of occurrences of the given value.
      Specified by:
        `getCount` in interface `IMemoryView<T>`
      Returns:
        the number of occurrences

    - #### getCountUnsafe

          public int getCountUnsafe(java.lang.Object value)

      Description copied from interface: `IMemoryView`
      Returns the number of occurrences of the given value (which may be of any type).
      Specified by:
        `getCountUnsafe` in interface `IMemoryView<T>`
      Returns:
        the number of occurrences

    - #### containsNonZero

          public boolean containsNonZero(T value)

      Specified by:
        `containsNonZero` in interface `IMemoryView<T>`
      Returns:
        true if the given value is contained with a nonzero multiplicity

    - #### containsNonZeroUnsafe

          public boolean containsNonZeroUnsafe(java.lang.Object value)

      Specified by:
        `containsNonZeroUnsafe` in interface `IMemoryView<T>`
      Returns:
        true if the given value (which may be of any type) is contained with a nonzero multiplicity

    - #### clearAllOf

          public void clearAllOf(T value)

      Description copied from interface: `IMemory`
      Removes all occurrences of the given value from the memory.
      Specified by:
        `clearAllOf` in interface `IMemory<T>`

    - #### iterator

          public java.util.Iterator<T> iterator()

      Specified by:
        `iterator` in interface `java.lang.Iterable<T>`

    - #### toString

          public java.lang.String toString()

      Specified by:
        `toString` in interface `org.eclipse.collections.api.map.primitive.ObjectIntMap<T>`
      Specified by:
        `toString` in interface `org.eclipse.collections.api.PrimitiveIterable`
      Overrides:
        `toString` in class `org.eclipse.collections.impl.map.mutable.primitive.ObjectIntHashMap<T>`

    - #### distinctValues

          public java.util.Set<T> distinctValues()

      Description copied from interface: `IMemoryView`
      The set of distinct values
      Specified by:
        `distinctValues` in interface `IMemoryView<T>`

    - #### forEachEntryWithMultiplicities

          public void forEachEntryWithMultiplicities(java.util.function.BiConsumer<T,java.lang.Integer> entryConsumer)

      Description copied from interface: `IMemoryView`
      Process contained values with their multiplicities
      Specified by:
        `forEachEntryWithMultiplicities` in interface `IMemoryView<T>`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `org.eclipse.collections.impl.map.mutable.primitive.ObjectIntHashMap<T>`

    - #### equals

          public boolean equals(java.lang.Object obj)

      Overrides:
        `equals` in class `org.eclipse.collections.impl.map.mutable.primitive.ObjectIntHashMap<T>`